"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = overflow;

var MAX_SAFE_INTEGER = 0x1fffffffffffff;

function overflow(num_str) {
  var e = void 0,
      i = void 0,
      len = void 0;
  var str = num_str.trim();
  var str_no_sign = str;

  if (str[0] === "-" || str[0] === "+") {
    str_no_sign = str = str.slice(1);
  }

  if ((e = str.indexOf(".")) > -1) {
    str = str.replace(".", "");
  }

  if ((i = str.search(/e/i)) > 0) {
    if (e < 0) e = i;
    e += +str.slice(i + 1);
    str = str.substring(0, i);
  } else if (e < 0) {
    e = str.length;
  }

  for (i = 0; str.charCodeAt(i) === 48; i++) {}

  for (len = str.length; str.charCodeAt(--len) === 48;) {}

  str = str.slice(i, len + 1);

  if (str) {
    e = e - i - 1;

    return str.length > 15 && (str_no_sign > MAX_SAFE_INTEGER || str_no_sign !== +str_no_sign + "") || e < -308 || e > 308;
  }
  return false;
}